/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


diaryServices.factory('ClientConfig', function ( TemplateRouting, UIGridOptions,RequiredDateFactory,StyleRouting,DriverUIGridOptions) {


    var route = function (url) {
        return TemplateRouting.route(url);
    };

    var requestGridOptions = function () {
        return UIGridOptions.requestGridOptions();
    };

    var taskGridOptions = function () {
        return UIGridOptions.taskGridOptions();
    };
    
    var warehouseGridOptions = function(){
        return UIGridOptions.warehouseGridOptions();
    };

    var getRequiredDate  = function(requiredDate,afternoon){
        return RequiredDateFactory.getRequiredDate(requiredDate,afternoon);
    };
    
    var requestStyle = function( requestId ){
        return StyleRouting.requestStyle( requestId ); 
    };
    
    var driverGridOptions = function(){
        return DriverUIGridOptions.driverGridOptions();
    };
    
    return{
        route: route,
        requestGridOptions : requestGridOptions,
        taskGridOptions : taskGridOptions,
        warehouseGridOptions: warehouseGridOptions,
        getRequiredDate : getRequiredDate,
        requestStyle : requestStyle,
        driverGridOptions : driverGridOptions
    };

    

});


diaryServices.factory('TemplateRouting', function (Configuration, ClientConfigDefinitions) {

    var route = function (url) {
        var prepend = 'client/default/';
        if (Configuration.getConfiguration().clientconfig === ClientConfigDefinitions.get().GKHIRE) {
            prepend = 'client/gkhire/';
        }
        ;
        return prepend + url; //hardcoded initially
    };

    return{
        route: route
    };
});

diaryServices.factory('StyleRouting', function (Configuration, ClientConfigDefinitions,RequestTypeDefinitions) {
    
    var requestStyle = function( requestId ){
        var style = 'defaultRequestStyle.css';
        if (Configuration.getConfiguration().clientconfig === ClientConfigDefinitions.get().GKHIRE) {
            switch(requestId){
                case RequestTypeDefinitions.get().DELIVERY.id:
                    //style = 'deliveryRequestStyle.css';
                    style = 'deliveryBackground';
                    break;
                case RequestTypeDefinitions.get().COLLECTION.id:
                    //style = 'collectionRequestStyle.css';
                    style = 'collectionBackground';
                    break;
                case RequestTypeDefinitions.get().HOLD.id: 
                    //style = 'onHoldRequestStyle.css';
                    style = 'onholdBackground';
                    break;
                case RequestTypeDefinitions.get().REPAIR.id:
                    //style = 'repairRequestStyle.css';
                    style = 'repairBackground';
                    break;
                case RequestTypeDefinitions.get().CHANGEOVER.id:
                    //style = 'deliveryRequestStyle.css';
                    style = 'deliveryBackground';
                    break;
                case RequestTypeDefinitions.get().OTHER.id:
                    //style = 'otherRequestStyle.css';
                    style = 'otherBackground';
                    break;
                case RequestTypeDefinitions.get().ALL.id:
                    //style = 'allRequestStyle.css';
                    style = 'allBackground';
                    break;
                case RequestTypeDefinitions.get().ASSIGNED.id:
                    //style = 'assignedRequestStyle.css';
                    style = 'assignedBackground';
                    break;
                case RequestTypeDefinitions.get().COMPLETE.id:
                    //style = 'completedRequestStyle.css';
                    style = 'completedBackground';
                    break;
            };
        };
        
        return style; 
    };
    

    return{
        requestStyle: requestStyle
    };
});




diaryServices.factory('UIGridOptions', function (Configuration,ClientConfigDefinitions) {


    var requestGridOptions = function () {
        var gridOptions = [
            {field: 'requestId', name: 'ID', type: 'number'},
            {field: 'runCategory.description', name: 'Run'},
            {field: 'employee.name', name: 'Employee'},
            {field: 'driver.name', name: 'Driver'},
            {field: 'company.name', name: 'Company', cellTooltip:
                        function (row, col) {
                            return row.entity.company.address;
                        }
            },
            {field: 'address.address', name: 'Site',
                cellTemplate: '<div title="{{COL_FIELD}}" class="ui-grid-cell-contents ">{{COL_FIELD | split : \'\\n\' : 0 }}</div>',
                cellTooltip:
                        function (row, col) {
                            return row.entity.address.address;
                        }
            },
            {field: 'contact.name', name: 'Contact', cellTooltip:
                        function (row, col) {
                            var details = "";
                            angular.forEach(row.entity.contact.contactDetails, function (each) {
                                details = details + each.contactDetailCategoryId.description + " : "
                                        + each.detailData + "\n";
                            });
                            return details;
                        }},
            {field: 'orderNumber', name: 'Order No'},
            {field: 'equipementDetails', name: 'Equipment', cellTooltip:
                        function (row, col) {
                            return row.entity.equipementDetails;
                        }},
            {field: 'priceAgreed', name: 'Price Agreed'},
            {field: 'transportDetails', name: 'Transport'},
            {field: 'requiredDate', name: 'Expected', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}
        ];

        if (Configuration.getConfiguration().clientconfig === ClientConfigDefinitions.get().GKHIRE) {
            
                   
                
            gridOptions = [
                    
                
                {field: 'requestId', name: 'ID', width: 60, type: 'number'},
                
                {field: 'requestType.description', name: 'Type', width: 80},
                {field: 'company.name', name: 'Company', width: 250 , cellTooltip:
                            function (row, col) {
                                return row.entity.company.address;
                            }
                },
                {field: 'address.name', name: 'Site', width: 150,
                    cellTemplate: '<div title="{{COL_FIELD}}" class="ui-grid-cell-contents ">{{COL_FIELD | split : \'\\n\' : 0 }}</div>',
                    cellTooltip:
                            function (row, col) {
                                return row.entity.address.address;
                            }
                },
                              
                {field: 'equipementDetails', name: 'Equipment', cellTooltip:
                            function (row, col) {
                                return row.entity.equipementDetails;
                            }},
                {field: 'driver.name', name: 'Driver', width: 150, sortingAlgorithm: function(a,b){return a > b}},                                
                {field: 'contact.name', name: 'Contact', width:150, cellTooltip:
                            function (row, col) {
                                var details = "";
                                angular.forEach(row.entity.contact.contactDetails, function (each) {
                                    details = details + each.contactDetailCategoryId.description + " : "
                                            + each.detailData + "\n";
                                });
                                return details;
                            }},  
                {field: 'runCategory.description', name: 'Priority', width:90},
                {field: 'requiredDate', name: 'Day', width:80, cellTemplate: '<div  class="ui-grid-cell-contents ">{{COL_FIELD | date :\'EEE\' }}</div>'},                        
                {field: 'requiredDate', name: 'Expected', width:100, cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy\' }}</div>'},
                {field: 'currentAction.actionType.description', name: 'Action', width: 120},
                

            ];
        };

        return gridOptions;
    };

    var taskGridOptions = function () {
        var gridOptions = [
            {field: 'actionType.description', name: 'Action'},
            {field: 'actionPriority.description', name: 'Priority'},
            {field: 'actorPersonId.name', name: 'Actor'},
            {field: 'acteePersonId.name', name: 'Actee'},
            {field: 'comment', name: 'Description'},
            {field: 'dateScheduled', name: 'Scheduled Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
            {field: 'dateCompleted', name: 'Completed Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}

        ];
        
        if (Configuration.getConfiguration().clientconfig === ClientConfigDefinitions.get().GKHIRE) {
            gridOptions = [
                {field: 'customerName', name: 'Customer'},
                {field: 'acteePersonId.name', name: 'Contact'},
                {field: 'comment', name: 'Description'},
                {field: 'actionType.description', name: 'Action'},
                {field: 'actionPriority.description', name: 'Priority'},
                {field: 'actorPersonId.name', name: 'Employee'}, 
                {field: 'dateScheduled', name: 'Scheduled Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
                {field: 'dateCompleted', name: 'Completed Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}

            ];
        };
        
        return gridOptions;
    };
    
    var warehouseGridOptions = function () {
        var gridOptions = [
            {field: 'actionType.description', name: 'Action'},
            {field: 'actionPriority.description', name: 'Priority'},
            {field: 'siteAddress',name: 'Site'},
            {field: 'actorPersonId.name', name: 'Actor'},
            {field: 'acteePersonId.name', name: 'Actee'},
            {field: 'comment', name: 'Description'},
            {field: 'dateScheduled', name: 'Scheduled Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
            {field: 'dateCompleted', name: 'Completed Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}

        ];
        
        if (Configuration.getConfiguration().clientconfig === ClientConfigDefinitions.get().GKHIRE) {
            gridOptions = [
                {field: 'customerName', name: 'Customer'},
                {field: 'acteePersonId.name', name: 'Contact'},
                {field: 'comment', name: 'Description',cellTooltip:
                            function (row, col) {
                                return row.entity.comment;
                            }},
                {field: 'siteAddress',name: 'Site',cellTooltip:
                            function (row, col) {
                                return row.entity.siteAddress;
                            }},
                {field: 'actionType.description', name: 'Action'},
                {field: 'actionPriority.description', name: 'Priority'},
                {field: 'actorPersonId.name', name: 'Employee'}, 
                {field: 'dateScheduled', name: 'Scheduled Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}
                //{field: 'dateCompleted', name: 'Completed Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}

            ];
        };
        
        return gridOptions;
    };



    return{
        requestGridOptions: requestGridOptions,
        taskGridOptions: taskGridOptions,
        warehouseGridOptions: warehouseGridOptions
    };

});

diaryServices.factory('DriverUIGridOptions', function (Configuration,ClientConfigDefinitions) {

    var driverGridOptions = function () {
        var gridOptions = [
            {field: 'actionType.description', name: 'Action'},
            {field: 'actionPriority.description', name: 'Priority'},
            {field: 'actorPersonId.name', name: 'Actor'},
            {field: 'acteePersonId.name', name: 'Actee'},
            {field: 'comment', name: 'Description'},
            {field: 'dateScheduled', name: 'Scheduled Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
            {field: 'dateCompleted', name: 'Completed Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}

        ];
        
        if (Configuration.getConfiguration().clientconfig === ClientConfigDefinitions.get().GKHIRE) {
            gridOptions = [
                {field: 'customerName', name: 'Customer'},
                {field: 'acteePersonId.name', name: 'Contact'},
                {field: 'comment', name: 'Description',
                    cellTooltip:
                        function (row, col) {
                            return row.entity.comment;
                        }
                },
                {field: 'requestTypeName', name: 'Action'},
                {field: 'siteAddress', name: 'Site Address',
                    cellTooltip:
                        function (row, col) {
                            return row.entity.siteAddress;
                        }
                },
                {field: 'actionPriority.description', name: 'Priority'},
                {field: 'actorPersonId.name', name: 'Employee'}, 
                {field: 'dateScheduled', name: 'Scheduled Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'},
                {field: 'dateCompleted', name: 'Completed Date', cellTemplate: '<div class="ui-grid-cell-contents ">{{COL_FIELD | date :\'dd/MM/yyyy HH:mm\' }}</div>'}

            ];
        };
        
        return gridOptions;
    };
    
   


    return{
        driverGridOptions: driverGridOptions
    };

});



diaryServices.factory('RequiredDateFactory', function (Configuration,ClientConfigDefinitions) {
    
    var getRequiredDate = function(requiredDate,afternoon){
        
        // GKHIRE want morning or afternoon only as the times so this logic set preconfigured times
        if (Configuration.getConfiguration().clientconfig === ClientConfigDefinitions.get().GKHIRE) {
            if( afternoon ){
                requiredDate.setHours(14);
                requiredDate.setMinutes(00);
            }else{
                requiredDate.setHours(09);
                requiredDate.setMinutes(00);
            }
        };
        
        return requiredDate;
    };
    
    return{
        getRequiredDate : getRequiredDate
    };
});