/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


diaryControllers.controller('LoginCtrl', function ($scope, $log, Configuration, $state, $uibModal , ClientConfigDefinitions) {
    // todo
    $log.info("Running LoginCtrl");
    Configuration.initialize();
    var configuration = Configuration.getConfiguration();
    
    $scope.baseURL = Configuration.getConfiguration().baseURL;
    $scope.isCollapsed = true;

    var modalInstance = $uibModal.open({
        animation: true,
        backdrop: 'static',
        keyboard: false,
        size: 'sm',
        scope: $scope,
        templateUrl: 'templates/login/loginModalTemplate.html',
        controller: 'LoginInstanceCtrl',
        controllerAs: 'LoginInstanceCtrl'

    });

    modalInstance.result.then(function (loginResult) {
        //$log.info( loginResult );
        configuration.operatorId = loginResult.operatorId;
        configuration.username = loginResult.username;
        configuration.password = loginResult.password;
        configuration.jsonwebtoken = loginResult.token;
        configuration.operatorName = loginResult.operatorName;
        configuration.clientconfig = loginResult.clientconfig; //0;
        Configuration.saveLoginConfiguration();
        
        $state.go('base.diary');
    });

});

diaryControllers.controller('LoginInstanceCtrl', function ($scope, $uibModalInstance, $log, $timeout, LoginService,Configuration) {
    $scope.username = "";
    $scope.password = "";
    $scope.showLoginFailed = false;
    $scope.loggingIn = "";
    
    $scope.login = function () {
        $scope.loggingIn = "glyphicon glyphicon-refresh spinning";
        LoginService.getToken($scope.username, $scope.password).then(function (r) {
            $log.info(r);
            if (r.jwtToken !== undefined ) {
                $scope.loggingIn="";
                $uibModalInstance.close({username: $scope.username,password: $scope.password,token: r.jwtToken ,operatorId: r.operatorId,operatorName: r.operatorName,clientconfig: r.clientconfig});
            } else {
                Configuration.clearLoginConfiguration();
                $scope.showLoginFailed = true;
                $timeout(function () {
                    $scope.showLoginFailed = false;
                    $scope.loggingIn="";
                }, 2000);
            };
        });
    };
});

diaryControllers.directive('myEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if(event.which === 13) {
                scope.$apply(function (){
                    scope.$eval(attrs.myEnter);
                });

                event.preventDefault();
            }
        });
    };
});
