/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */



diaryServices.factory('RunScheduleReportService', function ($q, $http, Configuration, $log) {


    var runScheduleReport = function (webDiaryReportBean) {
        var reportPromise = $q.defer();

        $http.post(Configuration.getConfiguration().runScheduleReportUrl, webDiaryReportBean, {responseType: 'arraybuffer'}).then(function (response) {
            //$log.info( r.data );
            reportPromise.resolve(response); // return token
        },
                function (error) {
                    //$log.error( error );
                    reportPromise.resolve(""); // on error return empty token
                });

        return reportPromise.promise;
    };


    return{
        runScheduleReport: runScheduleReport
    };
});

diaryServices.factory('RunWarehouseReportService', function ($q, $http, Configuration, $log) {


    var runWarehouseReport = function (webDiaryReportBean) {
        var reportPromise = $q.defer();

        $http.post(Configuration.getConfiguration().runWarehouseReportUrl, webDiaryReportBean, {responseType: 'arraybuffer'}).then(function (response) {
            //$log.info( r.data );
            reportPromise.resolve(response); // return token
        },
                function (error) {
                    //$log.error( error );
                    reportPromise.resolve(""); // on error return empty token
                });

        return reportPromise.promise;
    };


    return{
        runWarehouseReport: runWarehouseReport
    };
});

diaryServices.factory('ViewReportService', function ($q, Configuration, $log, $sce, $uibModal,ClientConfig) {


    var viewReport = function (report) {
        var file = new Blob([report], {type: 'application/pdf'});
        var fileURL = URL.createObjectURL(file);
        var viewerScope = {};
        viewerScope.content = $sce.trustAsResourceUrl(fileURL);
        var modalInstance = $uibModal.open({
            animation: true,
            //template: '<object data="{{content}}" type="application/pdf" style="height=700"></object>',
            //template: '<body style="background-color: rgb(38,38,38); height: 100%; width: 100%; overflow: hidden; margin: 0"><embed width="100%" height="600" name="plugin" id="plugin" ng-src="{{content}}" type="application/pdf" internalinstanceid="3"></body>',
            templateUrl: ClientConfig.route('templates/modals/pdfViewerModal.html'),
            controller: 'pdfViewerModalCtrl',
            size: 'lg',
            resolve: {
                content: function () {
                    return viewerScope.content;
                }
            }
        });
    };


    return{
        viewReport: viewReport
    };
});